diff --git a/drupal7/sites/all/themes/mayo/theme-settings.php b/drupal7/sites/all/themes/mayo/theme-settings.php
index b5532c83..f0e3f9b4 100644
--- a/drupal7/sites/all/themes/mayo/theme-settings.php
+++ b/drupal7/sites/all/themes/mayo/theme-settings.php
@@ -354,9 +958,53 @@ function mayo_form_system_theme_settings_alter(&$form, &$form_state) {
     '#type' => 'checkbox',
     '#title' => t('Use dark message colors'),
     '#default_value' => theme_get_setting('dark_messages'),
+    '#value' => 'dark-messages',
     '#description' => t('Check here if you use the dark color set. Colors for the status/warning/error messages are adjusted.'),
   );
 
+  /*
+   * Originally posted by dvessel (http://drupal.org/user/56782).
+   * The following will be processed even if the theme is inactive.
+   * If you are on a theme specific settings page but it is not an active
+   * theme (example.com/admin/apearance/settings/THEME_NAME), it will
+   * still be processed.
+   *
+   * Build a list of themes related to the theme specific form. If the form
+   * is specific to a sub-theme, all parent themes leading to it will have
+   * hook_form_theme_settings invoked. For example, if a theme named
+   * 'grandchild' has its settings form in focus, the following will be invoked.
+   * - parent_form_theme_settings()
+   * - child_form_theme_settings()
+   * - grandchild_form_theme_settings()
+   *
+   * If 'child' was in focus it will invoke:
+   * - parent_form_theme_settings()
+   * - child_form_theme_settings()
+   *
+   *  @see http://drupal.org/node/943212
+   */
+  $form_themes = array();
+  $themes = list_themes();
+  $_theme = $GLOBALS['theme_key'];
+  while (isset($_theme)) {
+    $form_themes[$_theme] = $_theme;
+    $_theme = isset($themes[$_theme]->base_theme) ? $themes[$_theme]->base_theme : NULL;
+  }
+  $form_themes = array_reverse($form_themes);
+
+  foreach ($form_themes as $theme_key) {
+    if (function_exists($form_settings = "{$theme_key}_form_theme_settings")) {
+      $form_settings($form, $form_state);
+    }
+  }
+
+  // Include custom form validation and submit functions
+  require_once(drupal_get_path('theme', 'mayo') . '/inc/forms/mayo.validate.inc');
+  require_once(drupal_get_path('theme', 'mayo') . '/inc/forms/mayo.submit.inc');
+
+  // Custom validate and submit functions
+  $form['#validate'][] = 'mayo_settings_validate';
+  $form['#submit'][] = 'mayo_settings_submit';
 }
 
 /**
@@ -389,18 +1037,18 @@ function mayo_page_width_validate($element, &$form_state) {
     $width = $element['#value'];
 
     // check if it is liquid (%) or fixed width (px)
-    if(preg_match("/(\d+)\s*%/", $width, $match)) {
+    if (preg_match("/(\d+)\s*%/", $width, $match)) {
       $num = intval($match[0]);
-      if(50 <= $num && $num <= 100) {
+      if (50 <= $num && $num <= 100) {
         return;
       }
       else {
         form_error($element, t('The width for the liquid layout must be a value between 50% and 100%.'));
       }
     }
-    else if(preg_match("/(\d+)\s*px/", $width, $match)) {
+    elseif (preg_match("/(\d+)\s*px/", $width, $match)) {
       $num = intval($match[0]);
-      if(700 <= $num && $num < 1600) {
+      if (700 <= $num && $num < 1600) {
         return;
       }
       else {
@@ -418,16 +1066,16 @@ function mayo_sidebar_width_validate($element, &$form_state) {
     $width = $element['#value'];
 
     // check if it is liquid (%) or fixed width (px)
-    if(preg_match("/(\d+)\s*%/", $width, $match)) {
+    if (preg_match("/(\d+)\s*%/", $width, $match)) {
       $num = intval($match[0]);
-      if(15 <= $num && $num <= 40) {
+      if (15 <= $num && $num <= 40) {
         return;
       }
       else {
         form_error($element, t('The width of the sidebar must be a value between 15% and 40%.'));
       }
     }
-    else if(preg_match("/(\d+)\s*px/", $width, $match)) {
+    elseif (preg_match("/(\d+)\s*px/", $width, $match)) {
       form_error($element, t('The width of the sidebar must be a value between 15% and 40%. Do not forget to add % character.'));
     }
   }
